From 80631e93ef59f4db2394e0478ecdb0154fd75f0b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 24 2020 20:07:30 +0000
Subject: [PATCH 926/2232] Add test involving empty vector


---

diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 73d6376..9ace1f2 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -145,6 +145,7 @@ pub mod ffi {
         fn r_take_rust_string(s: String);
         fn r_take_unique_ptr_string(s: UniquePtr<CxxString>);
         fn r_take_ref_vector(v: &CxxVector<u8>);
+        fn r_take_ref_empty_vector(v: &CxxVector<u64>);
         fn r_take_rust_vec(v: Vec<u8>);
         fn r_take_rust_vec_string(v: Vec<String>);
         fn r_take_ref_rust_vec(v: &Vec<u8>);
@@ -313,6 +314,11 @@ fn r_take_ref_vector(v: &CxxVector<u8>) {
     assert_eq!(slice, [20, 2, 0]);
 }
 
+fn r_take_ref_empty_vector(v: &CxxVector<u64>) {
+    assert!(v.as_slice().is_empty());
+    assert!(v.is_empty());
+}
+
 fn r_take_rust_vec(v: Vec<u8>) {
     let _ = v;
 }
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index a107c48..1f88d8b 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -400,6 +400,10 @@ extern "C" const char *cxx_run_test() noexcept {
   r_take_unique_ptr_string(
       std::unique_ptr<std::string>(new std::string("2020")));
   r_take_ref_vector(std::vector<uint8_t>{20, 2, 0});
+  std::vector<uint64_t> empty_vector;
+  r_take_ref_empty_vector(empty_vector);
+  empty_vector.reserve(10);
+  r_take_ref_empty_vector(empty_vector);
   r_take_enum(Enum::AVal);
 
   ASSERT(r_try_return_primitive() == 2020);

